import React, { Component } from 'react';
import dva from 'dva';
import { getApp } from '../../data/app';

const connect = (modelCreator, mapStateToProps, mapDispatchToProps, mergeProps, options) => (Comp) => {
  const { name, model } = modelCreator();
  const app = getApp();
  class StatefulComponent extends Component {

    componentWillMount() {
      app.model(model);
    }
    componentWillUnmount() {
      app.unmodel(model);
    }

    render() {
      const { children, ...rest } = this.props;
      const mapState = (state) => {
        const props = mapStateToProps ? mapStateToProps(state) : {};
        props[name] = state[model.namespace];
        return props;
      };
      const Output = dva.connect(mapState, mapDispatchToProps, mergeProps, options)(Comp);
      return (
        <Output {...rest}>
          { children }
        </Output>
      );
    }

  }
  return StatefulComponent;
};

export default connect;
